 	Module Precisions	 
       integer, PARAMETER::DP=KIND(1.d0)

       END MODULE PRECISIONS        		
!c======================================================================
!c======================================================================
	  MODULE dimension_probleme
	   integer,parameter::Nfluide=1
	   integer,parameter::Nface=4	   
	   INTEGER, PARAMETER::NFAMMAX=2
		END MODULE dimension_probleme
!c=============================================================
!c======================================================================
!c======================================================================
		MODULE PARAMETRE_EOS
	USE precisions
	USE dimension_probleme
	  INTEGER,parameter 					 :: NPARA_MAX=20	
      REAL(KIND=DP),dimension(NFLUIDE+1,NPARA_MAX),save :: PARA_EOS 
      REAL(KIND=DP),dimension(NFAMMAX,NPARA_MAX),save   :: PARA_PART 


		END MODULE PARAMETRE_EOS
!c======================================================================
!c======================================================================
	      MODULE COURANT
	   use precisions
	   use dimension_probleme

	   type cellule_gaz
	    real(kind=dp)				::ro
	    real(kind=dp)				::u
	    real(kind=dp)				::v
	    real(kind=dp)				::P
	    real(kind=dp)				::C
	    real(kind=dp)		     	::T
    	      
	   end type cellule_gaz
	
  	  type cellule_part
	   real(kind=dp)		::rop,nbre,tp,up,vp,diam	    	      
	  end type cellule_part

	 
		END MODULE COURANT
!c======================================================================
!c======================================================================
	MODULE GEOMETRIE
	use precisions
	use dimension_probleme

	 type maillage
         real(kind=dp)	::x,surf
	   real(kind=dp),dimension(NFACE)::lface,nx,nxl,xmid
	   real(kind=dp),dimension(NFACE)::dxp,dxm,dls2	  				   !! pour l'ordre2
	  end type maillage 

		type definition_domaine
	integer	::num_dom,nix,niy
	integer,dimension(2)::	type_limite

	end type  definition_domaine


	END MODULE GEOMETRIE

!======================================================================
!c======================================================================

                    PROGRAM DIFA_1D_ParcoursSIMUL
	
!======================================================================
!======================================================================
	 use precisions    
	 use dimension_probleme
     use PARAMETRE_EOS
	 use COURANT
	 use geometrie

	implicit none

	INTEGER NFAM,NEQ,IDIPHA,ICOUPLE,IORDRE
 	INTEGER NX
	INTEGER NEQG,ILIMITEUR,ILIMITEURP
	INTEGER NEQTOT
	
	real(kind=dp)::CFL

! MESH

	type(maillage),dimension(:),allocatable::grid
	type(definition_domaine) 			::def_bloc


     	REAL(KIND=DP) Long_Physique
     
! METHODE  
	real(kind=dp), allocatable,dimension(:,:) :: SOURCE
     
     	real(kind=dp), allocatable,dimension(:,:) ::VAR,VART,GRD_PRIM


	real(kind=dp), allocatable,dimension(:) 	  :: FLUX,SOMFLUX	

	real(kind=dp), allocatable,dimension(:,:,:) ::SLOPE 

	real(kind=dp), allocatable,dimension(:,:,:) :: VARI


	real(kind=dp), allocatable,dimension(:,:,:) ::VARP,PRIM_FACE

	
! limite 
       real(kind=dp), allocatable,dimension(:,:,:) ::VARLIM
	 real(kind=dp), allocatable,dimension(:,:) ::GRAVLIM,NORMLIM
	
!  GAZ 
	type(cellule_gaz),dimension(:),allocatable::cell_gaz	

!  ESPECE 	
	real(kind=dp)  ::	     ROGIL,ROGIR,ROGIS	


! DIVERS
	real(kind=dp)::DT,DTCFL
		real(kind=dp)::DXS2    
! PARTICULES
	type(cellule_part),dimension(:,:),allocatable::cell_part
! Calculde l'attnuation du choc

	REAL*8 Xchoc_init,Pchoc_init


!---------------------------------------------------------------------------
!     DECLARATION AUTRE QUE DES TABLEAUX  
!---------------------------------------------------------------------------
! DIVERS
	INTEGER KPRINT
	INTEGER IFILE,NCOURBE,I,K,IEQ,KT,KMAX
	INTEGER  IEQSTARTP,choix_cd
	INTEGER IFACE,KINSTA
	INTEGER Lire_FileP
	INTEGER NPARAMETRE
	REAL*8 EPS,PI,TEMPS,DT0,dx

! PARTCIULES 
	REAL*8 ROPINJMIN

! Position des capteurs
	real(kind=dp)	::XCP1,XCP2,XCP3
	INTEGER		::ICP1,ICP2,ICP3
! position onde de choc et nuage
	real(kind=dp)	::XODC,XCL,LCL
	INTEGER		::IODC,ICL1,ICL2
	
 
!  DONNEES THERMO ET PROPRIETES PHYSIQUES
	REAL*8 DMUAIR,PRANT,CPAL,CPALOX
	EXTERNAL DMUAIR,PRANT,CPAL,CPALOX

	
	CHARACTER*16 FILE1,FILE2
	
!C ---------------------------------------------------------
!C			INITIALISATION GENERALE
!C ---------------------------------------------------------
	PI=DACOS(-1.D0)
	ROPINJMIN=1.0D9
!C--------------------------------------------------------------------
!C 		 LECTURE DU FICHIER 'DATAINIT'
!C--------------------------------------------------------------------

	OPEN (UNIT=110 , FILE='DATAINIT' ,    STATUS='UNKNOWN')
	READ(110,*)  
	READ(110,*)KMAX,KPRINT
	READ(110,*)KINSTA 	
	READ(110,*) 
    READ(110,*)IDIPHA
	READ(110,*)DT0,CFL
	READ(110,*)
	read(110,*)NX
	read(110,*)Long_Physique
	read(110,*)
	read(110,*)XODC 
	read(110,*)
	read(110,*)Xcp1,Xcp2,Xcp3
	read(110,*)
	read(110,*)XCL,LCL 
	read(110,*)
	read(110,*)choix_cd
	read(110,*)
	read(110,*)FILE1
	read(110,*)FILE2
	CLOSE(110)

	FILE1=trim(FILE1)
	FILE2=trim(FILE2)

	ICOUPLE=1
	def_bloc%type_limite(1)=1
	def_bloc%type_limite(2)=1

!=========================================================
! Variables modifiable par un utilisateur avanc
!=========================================================
	 EPS=1.d-5
	 Lire_FileP=1
	 NFAM=1
     
	IORDRE=2	!!:IORDRE (1 ou 2)
	ILIMITEUR=2
	ILIMITEURP=2
				!         Nomenclature des limiteurs
				! (0:pas de limiteur)
				! (1:minmod)
				! (2:vanleeer)
				! (3:van albada)
				! (4:collela et woodward)
				! (5:superbee roe)
				! (6:superbee CHAKRAVARTHY ET OSHER)

!=========================================================

	 IF(KINSTA.EQ.0)KINSTA=KMAX+1
	 IFILE=0
	 NCOURBE=0

!c======================================================================
!c	LECTURE DE LA DIMENSION  DES TABLEAUX
!c======================================================================

       NEQG	=4
       NEQ=	NFAM*6+NEQG
	  NEQTOT=NEQ
	 IEQSTARTP=NEQG+1
 	 IF(IDIPHA.EQ.0) NEQTOT=NEQG
!c======================================================================
!c				ALLOCATION DES TABLEAUX
!c======================================================================
!c general
  	allocate ( cell_gaz(0:NX+1),cell_part(0:NX+1,NFAM) )	

!c maillage
	allocate ( grid(0:NX+1)    )
!c schma
	allocate(									     &
             VAR		(0:NX+1,NEQ),					     &
     	  	 GRD_PRIM	(0:NX+1,NEQ),					     &
             VART	(0:NX+1,NEQ),						     &
             SOURCE	(0:NX+1,NEQ),					     &
             FLUX	(NEQ),							     &
             SOMFLUX	(NEQ)							     &
             )
!
	allocate(									     &
      	   VARP 	(0:NX+1,4,NEQ),					     &
      	   SLOPE	(0:NX+1,4,NEQ),					     &
      	   VARI	(0:NX+1,4,NEQ),					     &
      	   PRIM_FACE(0:NX+1,4,NEQ)					     &
               )

!c limite 
	allocate(									     &		
      	   VARLIM(1:NX,0:1,NEQ),					     &
      	   NORMLIM(1:NX,2),						     &
      	   GRAVLIM(1:NX,2)						     &
               )
  


!c====================================================================== 
!c AFFECTAION DU PAS DE TEMPS LOCAL
	IF(CFL.eq.0.) DT=DT0

!C--------------------------------------------------------------------
!C 	ECRITURE DES DONNEES DE CONTROLES
!C--------------------------------------------------------------------
 


	WRITE(*,*)
	WRITE(*,*)' ------------------------------------------'
	WRITE(*,*)'    Ecriture DES DONNEES DE CONTROLES'
	WRITE(*,*)'  NBRE D''ITERATION MAX',KMAX
	WRITE(*,*)'  ECRITURE DES FICHIERS PLOT TOUS LES',KPRINT
	WRITE(*,*)


	IF(IDIPHA.EQ.0)WRITE(*,*)'   CALCUL MONOPHASIQUE:'
	IF(IDIPHA.EQ.1)	THEN
	   WRITE(*,*)'   CALCUL DIPHASIQUE:'
	   write(*,*)'  Choix du coefficient de frottement:'
		if(choix_cd==1)WRITE(*,*)'   		-Loi de Stokes'
		if(choix_cd==2)WRITE(*,*)'   		-Loi de Clift '
		if(choix_cd==3)WRITE(*,*)'   		-Loi de Jourdan '
	END IF
	WRITE(*,*)
	IF(IORDRE.EQ.1)WRITE(*,*)'   METHODE DE CALCUL A L''ORDRE 1'
	IF(IORDRE.EQ.2)WRITE(*,*)'   METHODE DE CALCUL A L''ORDRE 2'

	
 	WRITE(*,*) 
        
	IF(IORDRE.EQ.2)WRITE(*,*)'   - CHOIX DU LIMITEUR :'
	IF(IORDRE.EQ.2) THEN
	IF (ILIMITEUR.EQ.0 )WRITE(*,*)'                  AUCUN       '
	IF (ILIMITEUR.EQ.1 )WRITE(*,*)'                  MINMOD      '
	IF (ILIMITEUR.EQ.2 )WRITE(*,*)'                  VANLEER     '
	IF (ILIMITEUR.EQ.3 )WRITE(*,*)'         	 VANALBADA   '
	IF (ILIMITEUR.EQ.4 )WRITE(*,*)'          COLLELA  ET WOODWART'
	
	
	IF (ILIMITEUR.EQ.5 )WRITE(*,*)'          	 ROE  SUPERBEE '
	
	
	IF (ILIMITEUR.EQ.6 )WRITE(*,*)'         CHAKRAVARTHY ET OSHER '
	END IF
	WRITE(*,*)

	
	
	
	IF(CFL.EQ.0.D0)WRITE(*,*)'PAS DE TEMPS FIXE'
	IF(CFL.EQ.0.D0)WRITE(*,*)'DT =',DT0 
	IF(CFL.NE.0.D0)WRITE(*,*)'PAS DE TEMPS FIXE PAR RAPPORT AU CFL'
	IF(CFL.NE.0.D0)WRITE(*,*)'CFL =',CFL




!----------------------------------------------------------------------
!               OUVERTURE DES FICHIERS
!----------------------------------------------------------------------
2002       FORMAT(A10,1X,I4,A4,1X,I4,A12)   

	 OPEN (UNIT=12,FILE=FILE1,STATUS='UNKNOWN')

!----------------------------------------------------------------------
!			LECTURE DE LA GEOMETRIE
!-----------------------------------------------------------------------
	 
	write(*,*)
	write(*,*)'	---------------------------------------------------'
	write(*,*)'		on cree les maillages'
	write(*,*)'	---------------------------------------------------'
 
	

       CALL GENMESH_MD(grid,def_bloc,Long_Physique, NX)

	write(*,*)' Longueur du domaine genmesh',grid(NX)%XMID(2)
 

!======================================================================
!         recherche des indices des capteurs
!======================================================================
	icp1=1
	dxs2=grid(nx)%x
	do i=1,nx
        if(dabs(grid(i)%x-Xcp1).le. dxs2) then
	   dxs2=dabs(grid(i)%x-Xcp1)
	   icp1=i
        end if
	end do
	Icp2=1
	dxs2=grid(NX)%x
	do i=1,nx
	   if(   dabs(grid(i)%x-XCP2) < dxs2 ) then
	   dxs2=dabs(grid(i)%x-xcp2)
	   icp2=i
	   END IF
	end do
	Icp3=1
	dxs2=grid(NX)%x
	do i=1,nx
	   if(   dabs(grid(i)%x-XCP3) < dxs2 ) then
	   dxs2=dabs(grid(i)%x-xcp3)
	   icp3=i
	   END IF
	end do
!C position ODC
	iODC=1
	dxs2=grid(nx)%x
	do i=1,nx
        if(dabs(grid(i)%x-XODC).le. dxs2) then
	   dxs2=dabs(grid(i)%x-XODC)
	   iODC=i
        end if
	end do
	 
!C position Nuage
	iCL1=1
	dxs2=grid(nx)%x
	do i=1,nx
        if(dabs(grid(i)%x-XCL).le. dxs2) then
	   dxs2=dabs(grid(i)%x-XCL)
	   iCL1=i
        end if
	end do
	iCL2=1
	dxs2=grid(nx)%x
	do i=1,nx
        if(dabs(grid(i)%x-(XCL+LCL)).le. dxs2) then
	   dxs2=dabs(grid(i)%x-(XCL+LCL))
	   iCL2=i
        end if
	end do
	dx= (Long_Physique/dfloat(NX))
!-----------------------------------------------------------------------
!      INITIALISATION DES GRANDEURS THERMOPHYSIQUES DES PHASES        
!-----------------------------------------------------------------------
! DU GAZ


      PARA_EOS  = 0.d0

      write(*,*)'====================================================='	    	
	write(*,*)' Grandeurs Thermophysiques des Phases (lecture)'
	write(*,*)' on ouvre le fichier  ''air_gaz.inp'' '
  

      OPEN (UNIT=90,FILE='air_gaz.inp', STATUS='OLD')

	REAd(90,*)
	READ(90,*)NPARAMETRE
		 
	Do K=1,NPARAMETRE
	  READ(90,*)PARA_EOS(1,K)
!	write(*,*)k,NPARAMETRE,PARA_EOS(1,K)
	END DO
	close(90)
!c Des Particules

	PARA_PART  = 0.d0
	DO I=1, Nfam
		   
	write(*,*) 
	write(*,*)' on ouvre le fichier pour les particules'
	write(*,*)'      eau_liq.inp'

      OPEN (UNIT=90,  FILE='eau_liq.inp',STATUS='OLD')

	REAd(90,*)
	READ(90,*)NPARAMETRE	
	Do K=1,NPARAMETRE
	READ(90,*)PARA_PART(I,K)
	END DO
	close(90)
 	END DO
      write(*,*)'===================================================='
      TEMPS=0.d0

	

!-----------------------------------------------------------------------
!************  INITIALISATION DES GRANDEURS CONSERVATIVES***************
!-----------------------------------------------------------------------
!SOLUTION INITIALE GAZ
 

	  CALL INITGAZ(VAR,Pchoc_init,IODC,NX,NEQ)
 

!C SOLUTION INITIALE PARTCIULES

			IF (IDIPHA.EQ.1) THEN
	 

       CALL INITPART (VAR,grid,ropINJMin,ICL1,ICL2,NX,NFAM,NEQ,	     &
     		IEQSTARTP,Lire_FileP) 

	
			END IF		!FIN DIPHA

	Xchoc_init =grid(iODC)%x

	write(*,*)'======================================================'
	write(*,*) 
	write(*,*)' La position initiale du nuage est '
	write(*,*) 
	write(*,*)' XcL1 ',Xcl,'(m), soit l''indice', icl1
	write(*,*)'longueur du nuage',lcl,' (m)'
	write(*,*)' XcL2 ',Xcl+lcl,'(m), soit l''indice', icl2
	write(*,*) 
	write(*,*)'======================================================'
	write(*,*) 
	write(*,*)' La position des capteurs de pression '
	write(*,*) 
	write(*,*)' Position 1 =',xcp1,'(m)  soit l''indice ',icp1
	write(*,*)' Position 2 =',xcp2,'(m)  soit l''indice ',icp2
	write(*,*)' Position 2 =',xcp3,'(m)  soit l''indice ',icp3
	write(*,*) 
	write(*,*)'======================================================'
	write(*,*) 
	write(*,*)' La position de l''onde de choc '
	write(*,*) 
	write(*,*)' XODC =',XODC,'(m)  soit l''indice ',IODC
	write(*,*) 
	write(*,*)'======================================================'

	

!---------------------------------------------------------------------
!	INITIALSIATION DES DIFFERENTS VECTEURS
!---------------------------------------------------------------------

	DO I=0,NX+1
	DO IEQ=1,NEQ
	DO K=1,4
	 VARI(I,K,IEQ)=VAR(I,IEQ)
	 varp(i,K,IEQ)=VAR(I,IEQ)
	END DO
	END DO
	END DO
	

!----------------------------------------------------------------------- 
!	CALCUL DES CONDITIONS AUX LIMITES ANANt la premiere inetration
!----------------------------------------------------------------------- 
        
         CALL LIMGAZ(def_bloc,VAR,NX,NEQ,NEQG)
  
	IF(IDIPHA.EQ.1)CALL LIMPAR(def_bloc,VAR,NX,NEQ,IEQSTARTP)

	
!C----------------------------------------------------------------------
!C	ON CALCULE LES GRANDEURS PRIMITIVES
!C---------o------------------------------------------------------------
	
	 WRITE(*,*) 
	 WRITE(*,*)'TEMPS INITIAL', TEMPS
	 
	CALL PRIM(cell_gaz,cell_part,def_bloc,VAR,GRD_PRIM,		     &
                  EPS,ROPINJMIN, 						     &  				
       NX,NEQ,NFAM,IDIPHA,IEQSTARTP)
 
 
		CALL  ECRITPLOT(cell_gaz,cell_part,grid,FILE2,IFILE,NFAM,NX)	

		
	NCOURBE = NCOURBE +1



	
!C*********************************************************************
!C---------------------------------------------------------------------	 
!C ******************** DEBUT DE LA BOUCLE SUR LE TEMPS ***************
!C---------------------------------------------------------------------	 
!C*********************************************************************
		DO 999 KT=1,KMAX
!C---------------------------------------------------------------------- 
!C		CALCUL DES CONDITIONS AUX LIMITES
!C---------------------------------------------------------------------- 

        CALL LIMGAZ(def_bloc,VAR,NX,NEQ,NEQG)

	IF(IDIPHA.EQ.1)CALL LIMPAR(def_bloc,VAR,NX,NEQ,IEQSTARTP)
!C---------------------------------------------------------------------- 
!C	 calcul du pas de temps
!C----------------------------------------------------------------------       

	IF(CFL.NE.0.D0) THEN
	  DTCFL=9.d9
	 DO I=1,NX 
	 DTCFL=DMIN1(DTCFL,							     &
                 grid(I)%SURF/(dabs(cell_gaz(i)%U) +cell_gaz(i)%c))
	  END DO
  	  DT =CFL* DTCFL	          
	END IF
	TEMPS = TEMPS + DT

	CALL AFFICHE_TEMPS(KMAX,DT,KT)

	DO  IEQ=1,NEQTOT    
 	DO  IFACE=2,4,2	
      DO  I=0,NX+1
        varp(i,IFACE,IEQ)=VAR(I,IEQ)
	END DO
	END DO
	END DO

!C----------------------------------------------------------------------
!C SECOND ETAPE  :CALCUL DES FLUX PASSANT AU TRAVERS DE CHAQUE INTERFACE
!C                  ON UTILISE LES VALEURS U(N+1/2,J+1/2)
!C----------------------------------------------------------------------    
 					
	CALL INTERCELL (VARP,VARI,ROGIL,ROGIR,ROGIS,GRID,		     &
      IDIPHA,def_bloc,NX,NFAM,NEQ,NEQG,IEQSTARTP)

!C-----------------------------------------------------------------
!C		         ETAPE DE CONSERVATION
!C-----------------------------------------------------------------

       DO  I=1,NX
	CALL GREEN_FLUX(grid,VARI,SOMFLUX,FLUX,EPS,ROPINJMIN,		     &
                      IEQSTARTP,IDIPHA,I,NEQ,NFAM,NX,NEQTOT)	

      DO IEQ=1,NEQTOT
       VAR(I,IEQ)=VAR(I,IEQ)+DT*(SOMFLUX(IEQ))/grid(i)%SURF 
      ENDDO

    END DO    ! Bocule sur I=1,NX
              
!C---------------------------------------------------------------
!c		 COUPLAGE AVEC LA METHODE D'EULER MODIFIEE
!C
!C              ( POUR UN SYSTEME DIPHASIQUE)
!C---------------------------------------------------------------

            IF(IDIPHA.EQ.1.AND.ICOUPLE.EQ.1)THEN
	 CALL COUPLE(VAR,VART,SOURCE,DT,ROPINJMIN,EPS,			     &
          NEQG,NX,NEQ,NFAM,IEQSTARTP,choix_cd)
 
            ENDIF

!c--------------------------------------------------------------
!c       	CALCUL DES PRIMTIVES   A LA FIN DE L ETAPE
!c--------------------------------------------------------------

	CALL PRIM(cell_gaz,cell_part,def_bloc,VAR,GRD_PRIM,		     &
     	             EPS,ROPINJMIN,						     &   
        	NX,NEQ,NFAM,IDIPHA,IEQSTARTP)
!c-----------------------------------------------------------------
!C		ECRITURE DU FICHIER insta (12)
!c-----------------------------------------------------------------

		IF((MOD(KT,KINSTA).EQ.0).AND.(KINSTA.NE.0)) THEN
 	   
!c ecriture sur le fichier 'insta'

          WRITE(12,*)TEMPS/1.d-3,  						     &!1
             cell_gaz(icp1)%p/1.d5,    					     &!2
             cell_gaz(icp2)%p/1.d5,						     &!3
             cell_gaz(icp3)%p/1.d5
               end if ! FIN ECRITURE DU FICHIER insta

!c-----------------------------------------------------------------
!C		ECRITURE DU FICHIER PLOT  
!c-----------------------------------------------------------------

		IF(KPRINT.NE.0.AND.MOD(KT,KPRINT).EQ.0.and.kt.ge.0)THEN
			NCOURBE=NCOURBE+1
	CALL  ECRITPLOT(cell_gaz,cell_part,grid,FILE2,IFILE,NFAM,NX)
	WRITE(*,*)' ON A ECRIT LE FICHIER RESULTAT N.',NCOURBE

		END IF

999		CONTINUE
 	   write(*,*)'temps final',TEMPS  
	   deallocate(cell_gaz,cell_part,GRID,VAR,GRD_PRIM,VART,SOURCE, FLUX,SOMFLUX,   &
	              VARP, SLOPE,VARI,PRIM_FACE,VARLIM,NORMLIM,GRAVLIM)

2     STOP
      END


!=======================================================================
	SUBROUTINE INITGAZ(VAR,Pchoc_init,ichoc_init,NX,NEQ)

	
	 use precisions  
	 use dimension_probleme
       use PARAMETRE_EOS
	IMPLICIT NONE

	INTEGER NX,NEQ,ichoc_init
	REAL*8 VAR(0:NX+1,NEQ),Pchoc_init


! VARIABLE LOCALE
	INTEGER I,IFL
	INTEGER I1,I2 
	REAL*8 P1,RO1,U1,T1,ENER1
	REAL*8 P2,RO2,U2,T2,ENER2
	REAl*8 P2SURP1,UCHOC,DEBIT
	REAL*8 GA,GAP1,GAM1,CV

	IFL=1	
	GA	=PARA_EOS(IFL,1)
	GAp1	=GA+1.d0
	GAM1	=GA-1.d0	
	CV	=PARA_EOS(IFL,2)

	write(*,*)'==================================================='
	write(*,*)'  Condition INITIALE DU GAZ                       '	 
!=============================================================
!        lecture du ficheir de donnes initiales du gaz
!=============================================================
	OPEN (UNIT=111 , FILE='INITGAZ.DAT' ,    STATUS='OLD')
	READ(111,*)

	
	
	I1=0
	I2=ichoc_init
	READ(111,*)RO1,P1
	READ(111,*)U1
	READ(111,*)
	READ(111,*)P2SURP1
!=======================================================================	
		 
	ENER1=p1/ro1/(ga-1.d0)
 	T1   =ener1/cv

!  definbtion des grandeurs du choc par des relations analytiques
 
	P2=p2surp1*p1
! 	
	ro2=ro1*(p2surp1*gap1+gam1)/(p2surp1*gam1+gap1)
	      if(ro2.ne.ro1) then
	debit=dsqrt((p2-p1)/(1.d0/ro1-1.d0/ro2))
	uchoc=(debit+ro1*u1)/ro1
	ener2=P2/gam1/ro2
	u2=(ro2*uchoc-debit)/ro2


	      else
 	   ro2=ro1
	   u2=0.d0
	   ener2=P2/gam1/ro2
	     end if


	T2=ener2/CV
	uchoc=(ro1*u1+debit)/ro1

	write(*,*)'==================================================='
	write(*,*)'  			CHOC   STATIONNAIRE         '

	write(*,*)' ETAT 1 (devant le choc)'
	write(*,*)' rho ', ro1
	write(*,*)' P ', p1
	write(*,*)' u ', u1 
	write(*,*)' T ',T1
	write(*,*)
	write(*,*)' ETAT 2 (tat choqu)'
	write(*,*)' rho ', ro2
	write(*,*)' P ', p2
	write(*,*)' u ', u2 
	write(*,*)' T ',T2
	write(*,*)' Vitesse du choc',uchoc
	Pchoc_init=P2
!=======================================================================
! initilasation de l'tat choqu
	 
	 DO I=I1,I2	
	
	 VAR(I,1) =ro2*u2
	 VAR(I,3) =ro2*(ENER2+0.5D0*U2*U2)
     VAR(I,4)=RO2
	  

	END DO



   	
! initilasation de la zone basse pression
 
	DO I=I2+1,NX+1	
	 VAR(I,1) =ro1*u1
	 VAR(I,3) =ro1*(ENER1+0.5D0*U1*U1)
	
	 VAR(I,4)=RO1
	

	END DO

		

	RETURN
	END



!=======================================================================
       SUBROUTINE INITPART (VAR,grid,ropmin,ICL1,ICL2,NX,NFAM,NEQ,     &
                            IEQSTARTP,Lire_FileP) 


	 use precisions  
	 use dimension_probleme
	 use geometrie
       use PARAMETRE_EOS
	IMPLICIT NONE


	INTEGER NX,NEQ,IEQSTARTP,Lire_FileP,NFAM,ICL1,ICL2
      REAL*8 VAR(0:NX+1,NEQ)
	type(maillage),dimension(0:NX+1),intent(in)         ::grid	
	REAL*8 ropmin

!==========================================================
! Variables locales
!==========================================================
	INTEGER NF,NF1
	INTEGER I,I1,I2
	real(kind=dp)	::pi,roreel,cp,rop,diam,tp,upinit,vpinit
	real(kind=dp)	::dn0
	real(kind=dp)	::dxs2	



	Pi=dacos(-1.d0)
	ropmin=1.d9
	write(*,*)'==================================================='
	write(*,*)'  Condition INITIALE DU NUAGE                       '	 
	 
		If(Lire_FileP.eq.1 ) THEN ! on lit un fichier
!=============================================================
	OPEN (UNIT=111 , FILE='INITPART.DAT' ,    STATUS='OLD')
	

	dxs2=grid(nx)%x
	READ(111,*)
	 
       DO NF=1,NFAM
	READ(111,*)rop
	READ(111,*)diam
	READ(111,*)tp
	READ(111,*)UPINIT
	write(*,*)' pour les gouttes '
	write(*,*)'Densite apparente',rop,' (kg/m3)'
	write(*,*)'Diametre',diam/1.d-6,' (micron)'
	write(*,*)'Temperature',Tp,' (K)'
	write(*,*)'Vitesse',UPINIT,'  (m/s)'

	 NF1=(IEQSTARTP-1)+6*(NF-1) 
		 
	roreel=PARA_part(NF,1)
	cp	=PARA_part(NF,2) 

	if(rop.ne.0.d0) then
 	ropmin=dmin1(ropmin,rop)
	dn0=rop/roreel*6.d0/pi/(diam**3.d0)
	else 
	dn0=0.0d0
	end if
 
 	DO I=0,NX+1
        			 
	 VAR(I,NF1+1)=0.
	 VAR(I,NF1+2)=0.
	 VAR(I,NF1+3)=0.
	 VAR(I,NF1+4)=0.
	 VAR(I,NF1+5)=0.    !rop1 (alu)
       VAR(I,NF1+6)=0.D0	!rop2 (alumine)
	END DO
		 
			

!=======================================================================	
       DO I=ICL1,ICL2        			 
	 VAR(I,NF1+1)=ROP*UPINIT
	 VAR(I,NF1+2)=0.d0
	 VAR(I,NF1+3)=DN0
	 VAR(I,NF1+4)=ROP*CP*TP
	 VAR(I,NF1+5)=ROP    !rop1 (alu)
       VAR(I,NF1+6)=0.D0	!rop2 (alumine)
	END DO

	END DO 
!  calcul de l'indice initial du nuage		
		write(*,*) 
	
!=============================================================
		ElseIf(Lire_FileP.eq.0 ) THEN ! on code en dur
	write(*,*)' on VA calculer la solution initiale  PARTCIULES'
	ropmin=1.d9
!__on impose un fond pour tous les rangs
		I1=0
		I2=NX+1
 
	DO NF=1,NFAM
	NF1=(IEQSTARTP-1)+6*(NF-1) 
	roreel=PARA_part(NF,1)
	cp	=PARA_part(NF,2) 


	ROP=0.50
	Diam=45.d-6
	Tp=357.14d0  
	dn0=0.d0
	UPINIT=00.d0
	VPINIT=00.d0


	if(rop.ne.0.d0) then
 	ropmin=dmin1(ropmin,rop)
	dn0=rop/roreel*6.d0/pi/(diam**3.d0)
	else 
	dn0=0.0d0
	end if
	
	DO I=I1,I2
 	
	 VAR(I,NF1+1)=ROP*UPINIT
	 VAR(I,NF1+2)=ROP*VPINIT
	 VAR(I,NF1+3)=DN0
	 VAR(I,NF1+4)=ROP*CP*TP
	 VAR(I,NF1+5)=ROP    !rop1 (alu)
       VAR(I,NF1+6)=0.D0	!rop2 (alumine)

 
	END DO
	END DO	
 
! --- on met un carr dans le rang0

 

		I1=0
		I2=-1
		
	write(*,*)'      NFAM=',NFAM

	DO NF=1,NFAM
	
	NF1=(IEQSTARTP-1)+6*(NF-1) 
	roreel=PARA_part(NF,1)
	cp	=PARA_part(NF,2) 

! famille 1
	if(NF.eq.1) then
	ROP	=5.d0
	Diam	=33.d-5
	Tp	=222.d0

	 
	UPINIT=000.d0
	VPINIT=100.d0
 
	if(rop.ne.0.d0) then
 	ropmin=dmin1(ropmin,rop)
	dn0=rop/roreel*6.d0/pi/(diam**3.d0)
	else 
	dn0=0.0d0
	end if
	end if
! famille 2
	if(NF.eq.2) then
	ROP=5.0d0
	Diam=50.d-6
	Tp=300.d0

	 
	UPINIT=100.d0
	VPINIT=000.d0
 
	if(rop.ne.0.d0) then
 	ropmin=dmin1(ropmin,rop)
	dn0=rop/roreel*6.d0/pi/(diam**3.d0)
	else 
	dn0=0.0d0
	end if
	end if
	


	DO I=I1,I2
    		


	 VAR(I,NF1+1)=ROP*UPINIT
	 VAR(I,NF1+2)=ROP*VPINIT
	 VAR(I,NF1+3)=DN0
	 VAR(I,NF1+4)=ROP*CP*TP
	 VAR(I,NF1+5)=ROP    !rop1 (alu)
       VAR(I,NF1+6)=0.D0	!rop2 (alumine)

	END DO
	END DO


 
!=============================================================
		END IF  ! on code en dur
	 
	  
		RETURN
		END	

!=======================================================================
      SUBROUTINE VECSOURCE(VAR,SOURCE,                                 &
           ROPINJMIN,EPS,                                              &
           choix_cd,NEQG,NX,NY,NEQ,NFAM,IEQSTARTP)


       use precisions   
	 use dimension_probleme
       use PARAMETRE_EOS

	        IMPLICIT NONE
!    FONCTION MPI 



	INTEGER NX,NY,NEQ,NFAM,NEQG,IEQSTARTP,choix_cd

      REAL*8 VAR(0:NX+1,NEQ),SOURCE(0:NX+1,NEQ)
	REAL*8 ROPINJMIN,EPS
!  VARIABLES LOCALES
! PArtciules

!  GAZ 


	REAL*8 ROG,VGX
	REAL*8 CORREL
	REAL*8 E,CPG,LANDA
	REAL*8 GA,CVG,TGAZ,PRANT
!   ECOULEMENT
	REAL*8 VIT1,RE,CD,FX,TRAVAILF
	REAL*8 QV
    	REAL*8  NUSSEL,TAUT,TAUV,DMUG,PG
! PARTICULES

	REAL*8 ROP,VPX,CPP,VOLAL,VOLOXYDE,ROREEL
	REAL*8 DIAMETRE,TPAR,NBRE,VOL,ROREEL1,ROREEL2
      REAL*8 TSAT,CVAP
! DIVERS
	REAL*8 PI
	INTEGER I,J,NF,NF1,IEQ0,IFL


!-------------------------------------------------
	PI=DACOS(-1.D0)
	IEQ0=NEQG
	

        SOURCE=0.D0
       
!-------------------------------------------------
!		INITILASATION

	IFL=1
	GA	=PARA_EOS(IFL,1)
	CVG	=PARA_EOS(IFL,2)
	CPG	=CVG*GA
	DMUG	=PARA_EOS(IFL,6)
	PRANT	=PARA_EOS(IFL,7)
	LANDA = DMUG*CPG/PRANT
	    DO I=1,NX 
	    DO J=1,NY

!--------------------------------------------------------------
!     CALCUL DES VARIABLES PRIMITIVES GAZ
!--------------------------------------------------------------

	
     ROG = VAR(I,4)
      VGX   =VAR(I,1)/ROG
     
      E	=VAR(I,3)-0.5D0*ROG*VGX*VGX
	E	=E/ROG

	PG=(ga-1.d0)*rog*E
	
	TGAZ=E/CVG



!--------------------------------------------------------------
!     CALCUL DES VARIABLES PRIMITIVES PARTICULES
!--------------------------------------------------------------
      			DO NF=1,NFAM
				NF1=(IEQSTARTP-1)+6*(NF-1)
	 CPP	= PARA_part(NF,2) 
	 CVAP	= PARA_part(NF,3)
	 ROREEL1	= PARA_part(NF,1)
	 ROREEL2	= PARA_part(NF,1)
	 TSAT		= PARA_part(NF,4)

	
	ROP=VAR(I,NF1+5)+VAR(I,NF1+6)



		IF(ROP/ROPINJMIN.GT.EPS) THEN  

            
	  VPX=VAR(I,NF1+1)/ROP
        
        NBRE=VAR(I,NF1+3)

	  
        VOLAL 	= VAR(I,NF1+5)/ROREEL1/NBRE
        VOLOXYDE	= VAR(I,NF1+6)/ROREEL2/NBRE
	  VOL		= VOLAL+VOLOXYDE
        ROREEL	= ((VOLAL*ROREEL1)+(VOLOXYDE*ROREEL2))/VOL
        
       
	DIAMETRE=(6.D0/PI*VOL)**(1.D0/3.D0)
      
      TPAR=VAR(I,NF1+4)/ROP/CPP



!------------------------------------------------------------------------
!	CALCUL DES NOMBRES SANS DIMENSION
!------------------------------------------------------------------------

    TAUV = 0.5D0*DIAMETRE*DIAMETRE*ROREEL/9.D0/DMUG					  !temps de relaxation Dynamique
	TAUT=  1.5D0*PRANT*CPP/CPG*TAUV							  !temps de relaxation Thermique
        
      VIT1=dabs(VPX-VGX)

        RE=ROG*VIT1*DIAMETRE/DMUG

        IF (RE.EQ.0.D0) RE=1.D-6
	CORREL=DSQRT(RE)*(PRANT**1.D0/3.D0)



	NUSSEL = (2.D0+0.6D0*CORREL)

!------------------------------------------------------------------------


!	if(re.gt.1.d-6)write(*,*)'i',i,' re=',re
!	
!------------------------------------------------------------------------
!                   CALCUL DE LA TRAINEE
!------------------------------------------------------------------------



	if(re.le.1.d-6) then
	   cd=0.d0
	else 
	  
	  if(choix_cd ==1 ) then
	    cd=24.d0/re        
 	  else
 	   write(*,*) ' Attention le coeffient de frottement CD n est pas specifi  &
 	                dans la subrotine VECSOURCE'
 	   write(*,*) ' Le programme est arrete car il FAUt un coeffient de frottement '

 	   stop
 	  end if
	end if


      FX=PI/8.D0*ROG*(DIAMETRE*DIAMETRE)*CD*(VGX-VPX)*		     &	
                VIT1*NBRE   
     
       TRAVAILF=FX*VPX

!-----------------------------------------------------------------------
!                  CALCUL DE L ECHANGE DE CHALEUR
!--- 

     
	    QV=NBRE*PI*DIAMETRE*NUSSEL*LANDA*(TGAZ-TPAR)




!-----------------------------------------------------------------------
!                  AFFECTATION DES TERMES SOURCES AUX VECTEURS
!-----------------------------------------------------------------------              
!	write(*,*)i,j,fx,fy,qv,TGAZ,TPAR,RE

        SOURCE(I,1)= SOURCE(I,1)  -FX 
        SOURCE(I,2)= SOURCE(I,2) + 0.d0
        SOURCE(I,3)= SOURCE(I,3)  -QV  -TRAVAILF 
        SOURCE(I,4)= SOURCE(I,4)  + 0.d0
      
        SOURCE(I,NF1+1)  = + FX 
        SOURCE(I,NF1+2)  = 0.d0
        SOURCE(I,NF1+3)  = 0.d0 
        SOURCE(I,NF1+4)  = +  QV 
        SOURCE(I,NF1+5)  = 0.d0
        SOURCE(I,NF1+6)  = 0.D0
          
		  	 END IF
	                 END DO			!Fin des Familles
	END DO
	END DO
        

        RETURN
        END

!=======================================================================
	SUBROUTINE  AFFICHE_TEMPS(KMAX,DT,KT)
	IMPLICIT NONE

	INTEGER KMAX,Kt
	REAL*8 DT


        IF (KMAX.LT.100) THEN
 	 PRINT*,'KT',KT,'DT=',DT/1.D-6,'MICRO SEC'
	ELSE
	IF (KMAX.LT.1000) THEN
	 IF (MOD(KT,50).EQ.0) THEN
	  PRINT*,'KT',KT,DT
	 END IF 
	else
	IF (MOD(KT,500).EQ.0) THEN
	  PRINT*,'KT',KT,DT
	 END IF 
	end if
	END IF

	RETURN
	END


!=======================================================================



!=======================================================================
       SUBROUTINE COUPLE(VAR,VART,SOURCE,DT,				     &
            ROPMIN,EPS,								     &
            NEQG,NX,NEQ,NFAM,IEQSTARTP,choix_cd)

 	 use precisions   
	 use dimension_probleme
       use PARAMETRE_EOS

           		IMPLICIT NONE
	INTEGER NX,NEQ,NFAM,NEQG,IEQSTARTP,choix_cd

        REAL*8 VAR(0:NX+1,NEQ),VART(0:NX+1,NEQ)
        REAL*8 SOURCE(0:NX+1,NEQ)

	REAL*8 ROPMIN 
      REAL*8 EPS,DT

! VARIABLE LOCALE
	INTEGER I,IEQ,NY

	NY=1 
! PREDICTEUR

	CALL VECSOURCE(VAR,SOURCE,						     &
           ROPMIN,EPS,   							     &  
           choix_cd,NEQG,NX,NY,NEQ,NFAM,IEQSTARTP)


      DO 555 I=1,NX
	DO 555 IEQ=1,NEQ
          VART(I,IEQ)=VAR(I,IEQ)+DT*SOURCE(I,IEQ)
555	CONTINUE

! CORRECTEUR

	CALL VECSOURCE(VART,SOURCE,						     &
           ROPMIN,EPS,     							     &
           choix_cd,NEQG,NX,NY,NEQ,NFAM,IEQSTARTP)
        DO 560 I=1,NX
	  DO  IEQ=1,NEQ
         VAR(I,IEQ)=(VART(I,IEQ)+VAR(I,IEQ)				     &
    				+DT*SOURCE(I,IEQ)) /2.D0


	END DO



560     CONTINUE


        RETURN
        END
!=======================================================================
	SUBROUTINE ECRITPLOT(cell_gaz,cell_part,grid,FILE2,IFILE,NFAM,NX)

       use precisions    
	 use COURANT
	 use geometrie

       IMPLICIT NONE
	INTEGER NX,NFAM,IFILE


	type(cellule_gaz),dimension(0:NX+1),intent(in)  ::cell_gaz
	type(cellule_part),dimension(0:NX+1,NFAM),intent(in)  	     &
                                                  ::cell_part
	type(maillage),dimension(0:NX+1),intent(in)         ::grid		

!
!  VARIABLES LOCALES

	INTEGER I,NUMFILE,NF
	CHARACTER*16  FILE2

	NF=1

	                

! LECTURE ET ECRITURE
	

	NUMFILE=60+IFILE

	 	WRITE(*,*)' NOM DU FICHIER :',FILE2
	

	OPEN (UNIT=NUMFILE ,FILE=FILE2 ,STATUS='UNKNOWN')


 
	
	DO I=1,NX
 

	 WRITE(NUMFILE,300)grid(i)%x,						     &		!1
          	      cell_gaz(i)%u ,						     &		! 2
     	       	cell_gaz(i)%P ,						     &		! 3
     			cell_gaz(i)%T,						     &		! 4
      	        cell_gaz(i)%RO,						     &		! 5
     			cell_gaz(i)%C,						     &		! 6 
     			cell_part(i,NF)%UP,					     &		! 7
          		cell_part(i,NF)%NBRE,					     &		! 8
    			cell_part(i,NF)%ROP,					     &		! 9
     			cell_part(i,NF)%TP,					     &		! 10
     			cell_part(i,NF)%DIAM 								! 11
     			        END DO
!	CLOSE(NUMFILE)
 	WRITE(NUMFILE,* )



300     FORMAT(11E16.7) 
301     FORMAT(2i4)  
303     FORMAT(i3)  
302     FORMAT(E11.4)  

	RETURN 
	END
!=======================================================================
       
!=========================================================================
!	 ON CALCULE LE VECTEUR FLUX HHLC DIRECTEMENT 
!           ET NON PAS LES GRANDEURS CONSERVATIVES
!      L'INTEGRATION DES FLUX EST DONC DIFFRENTE (GREENHHL)
!
!     TOUTES LES GRANDEURS SONT DANS LE REPERE LI2 A LA FACE CONSIDEREE
!
!	LE VECTEUR FLUX A QUATRE COMPSANTE MINIMUM QUI SONT:
!
!
!		RHO U_NORMALE** 2  + P
!         RHO U_TANG * U_NRMALE
!        (RHO*E_TOTALE + P ) U_NORMALE
!		RHO(i) U_NORMALE
! 
!          On limite le nombre d'espece a 6 MAXIMAUM


       SUBROUTINE FLUHLLC(							     &
		RO_U_NORMAL_L,RO_U_TANG_L,ETOT_L,RO_L,ROI_L,PL,AL,	     &
      	 RO_U_NORMAL_R,RO_U_TANG_R,ETOT_R,RO_R,ROI_R,PR,AR,	     &
     			        RN,RT,ENR,RO,ROGIS				     )
           IMPLICIT    NONE
 
	
	REAL*8  RO_U_NORMAL_L, RO_U_TANG_L
	REAL*8  RO_U_NORMAL_R, RO_U_TANG_R
	REAL*8  RO_L,          RO_R
	REAL*8  ETOT_L,        ETOT_R
	REAL*8  ROI_L,ROI_R,ROGIS
	REAL*8  RO,RN,RT,ENR

! VARIABLES LOCALES

	REAL*8  SM,SR,SL
	REAL*8  UL,VL,EIL,PL,AL
	REAL*8  UR,VR,EIR,PR,AR
	REAL*8  FACT
	REAL*8  FLU_L(10),FLU_R(10),UU_L(10),UU_R(10)

	




!      INITIALISATION des vitesses ondes de Droite et Gauche
!      Etat gauche 
	UL = RO_U_NORMAL_L / RO_L
	VL = RO_U_TANG_L   / RO_L

          EIL=ETOT_L - (RO_U_NORMAL_L**2+RO_U_TANG_L**2)/2.D0/RO_L
!          PL=(GAMMA_L-1.D0) * EIL
!          AL=DSQRT(GAMMA_L * PL / RO_L)
	    



!      Etat droite 
          UR = RO_U_NORMAL_R / RO_R
	  VR = RO_U_TANG_R   / RO_R

          EIR=ETOT_R - (RO_U_NORMAL_R**2+RO_U_TANG_R**2)/2.D0/RO_R
!          PR=(GAMMA_R-1.D0) * EIR
!          AR=DSQRT(GAMMA_R * PR / RO_R)



	 
!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!      CALCUL DES VITESSES DES ONDES A DROITE ET A GAUCHE


	SL = DMIN1(UL-AL  ,  UR-AR)
	SR = DMAX1(UL+AL  ,  UR+AR)



!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!                       CALCUL DE LA VITESSE SM

	SM=(PR-PL + RO_L*UL*(SL-UL)-RO_R*UR*(SR-UR))/			     &
         (RO_L*(SL-UL)-RO_R*(SR-UR))


!______________________________________________________________
!			AFFECTATION DES VECTEURS
!______________________________________________________________

!  grandeurs conservatives  gauche
	    UU_L(1) = RO_L
	    UU_L(2) = RO_U_NORMAL_L
	    UU_L(3) = RO_U_TANG_L
	    UU_L(4) = ETOT_L
	    UU_L(5)=ROI_L
	  
!  Flux a agauche
	    FLU_L(1) = RO_U_NORMAL_L  
	    FLU_L(2) = RO_U_NORMAL_L  * UL  +  PL
 	    FLU_L(3) = RO_U_TANG_L    * UL   
 	    FLU_L(4) =(ETOT_L  + PL)  * UL          
	    FLU_L(5)=ROI_L       * UL
	 

!  grandeurs conservatives  droite
	    UU_R(1) = RO_R
	    UU_R(2) = RO_U_NORMAL_R
	    UU_R(3) = RO_U_TANG_R
	    UU_R(4) = ETOT_R
	    UU_R(5)=ROI_R

!  Flux a droite
	    FLU_R(1) = RO_U_NORMAL_R  
	    FLU_R(2) = RO_U_NORMAL_R  * UR  +  PR
 	    FLU_R(3) = RO_U_TANG_R    * UR   
 	    FLU_R(4) =(ETOT_R  + PR)  * UR  
	    FLU_R(5)=ROI_R         * UR




!_____________________________________________________________
! CALCUL DE LA SOLUTION en TERME DE FLUX, au bord de la maille (x/t = 0)
!_____________________________________________________________
	       IF(SL.GE.0.D0) THEN
	        RO=		FLU_L(1) 		  	
	        RN=		FLU_L(2)  	
	        RT=  	FLU_L(3)	
	        ENR=    FLU_L(4)
        	
	            ROGIS= FLU_L(5)
	           
	       END IF		  	
!--------------------
	       IF(SR.LE.0.D0) THEN
	        RO=		FLU_R(1)		  	
	        RN=		FLU_R(2)  	
	        RT=  	FLU_R(3)
	        ENR=	FLU_R(4)
        	      
	            ROGIS=FLU_R(5 )
	          

		 END IF	
!--------------------
		IF(SL.LT.0.D0.AND.SM.GT.0.D0) THEN
          
		 FACT=RO_L*(SL-UL)/(SL-SM)
	     ENR = ETOT_L / RO_L + (SM-UL) *(SM + PL/RO_L/(SL-UL) )


  	        RO=		FLU_L(1) + SL*( FACT     - UU_L(1) ) 		  	
	        RN=		FLU_L(2) + SL*( FACT*SM  - UU_L(2) )	  	
	        RT=  	FLU_L(3) + SL*( FACT*VL  - UU_L(3) )
	        ENR=	FLU_L(4) + SL*( FACT*ENR - UU_L(4) )
         
	    ROGIS=FLU_L(5)+SL*(FACT *(ROI_L/RO_L)-UU_L(5) ) 		  ! on peut simplifier
	    


		END IF
!--------------------
		IF(SR.GT.0.D0.AND.SM.LE.0.D0) THEN
          
		 FACT=RO_R*(SR-UR)/(SR-SM)
	     ENR = ETOT_R / RO_R + (SM-UR) *(SM + PR/RO_R/(SR-UR) )


  	        RO=		FLU_R(1) + SR*( FACT     - UU_R(1) ) 	 		  	
	        RN=		FLU_R(2) + SR*( FACT*SM  - UU_R(2) )		  	
	        RT=     FLU_R(3) + SR*( FACT*VR  - UU_R(3) )
	        ENR=	FLU_R(4) + SR*( FACT*ENR - UU_R(4) )
         
	  ROGIS= FLU_R(5)+SR*(FACT *(ROI_R/RO_R) - UU_R(5) )            ! on peut simplifier
	   


		END IF




	RETURN
      END

!=======================================================================

       SUBROUTINE GENMESH_MD(grid,def_bloc,Long_Physique,NX)

 	use precisions   
!	use COURANT
 	use dimension_probleme
	use geometrie

                  IMPLICIT NONE
	INTEGER  NX




	 type(definition_domaine) ::def_bloc
	 type(maillage),dimension(0:NX+1),intent(out)   ::grid
	 real(kind=dp) Long_Physique

	
! VARIABLE LOCALE
	INTEGER NIX
	INTEGER I,K,L
	INTEGER LIMITE
	
 	REAL(Kind=DP) ::DELTAX,X1,X2


!------------------------------------------------------------------
!	Cration des conditions aux limites de chaque sous domaine
!------------------------------------------------------------------


      DEF_BLOC%NIX	=nX

	
	NIX=NX
	

!=======================================================================
	deltax=Long_Physique/dfloat(NX)      !deltax constant pour chaque  
			
			DO i=1,Nx


	 X1= dfloat(i-1)*deltax
	 X2=X1+deltax

	 grid(i)%x	=	(X1+X2)/2.d0
	 grid(I)%SURF	=	deltax

	  do L=2,4,2
	   if (L.EQ.2) THEN
		grid(I)%nx(L)	=	1.d0
 		grid(I)%XMID(L)	= 	X2
		grid(I)%LFACE(L)=	1.d0	   
	    END IF

	   if (L.EQ.4) THEN
	grid(I)%nx(L)	=	-1.d0
 	grid(I)%XMID(L)	= 	X1
	grid(I)%LFACE(L)=	1.d0	   
	   END IF
!----------------------------------------------------------------------

	  end do
	 End Do


!-----------------------------------------------------------------
!	  ON AJOUTE UN CELLULE FICTIVE -- MODIF MULTAINE
!-----------------------------------------------------------------
!  DANS UN PREMIER TEMPS, ON FAIT UN CALCUL PAR EXTRAPOLATION
!  ENSUITE ON VERIFIE
!__________________________________________________________________


	LIMITE = 4
	I=0
	grid(I)%x		=2.0D0*grid(I+1)%Xmid(4)-grid(I+1)%X

	LIMITE = 2
	I=NIX+1
 	grid(I)%x		=0.0D0*grid(I-1)%Xmid(2)-grid(I-1)%X

!---------------------------------------------------------------------
! 			MODIF DES XFAC
!---------------------------------------------------------------------

	    	DO 1 I=1,NIX
            DO 1 L=1,NFACE
            DO  K=1,2
	        grid(I)%NXL(L)= grid(I)%NX(L)*grid(I)%LFACE(L)
            ENDDO
1           CONTINUE
	


!====================================================================
!			@--- ECRITURE DU FICHIER VERIFMESH -----@
!====================================================================


	RETURN
	END


!---------------------------------------------------------------------
! 		NOMBRE DE CARACTERE DU NOM DU FICHIER grid
!---------------------------------------------------------------------
	FUNCTION LNBLNK(CHAINE)
	
	IMPLICIT NONE
	
	INTEGER LNBLNK
	CHARACTER*40 CHAINE

!  Variable locales
	integer  i ,ilen
	character*1 carac
        ilen  = 40
	lnblnk=0
	do i=1,ilen
	carac = chaine (i:i)
	if(carac.ne.' ') then
         lnblnk = lnblnk  + 1
	end if

	end do

	return
	end


!=======================================================================
	SUBROUTINE GREEN_FLUX(grid,VARI,SOMFLUX,FLUX, 			     &
               EPS,ROPINJMIN,IEQ0,IDIPHA,I,				     &
                   NEQ,NFAM,NX,NEQ1)
       use precisions    
	 use COURANT
       use geometrie
	IMPLICIT NONE
	INTEGER IDIPHA,I,NEQ,NFAM,NX,NEQ1,IEQ0

	REAL*8 VARI(0:NX+1,4,NEQ),SOMFLUX(NEQ),FLUX(NEQ)
	REAL*8 ROPINJMIN,EPS
      type(maillage),dimension(0:NX+1),intent(in)      ::grid

! VARIABLE LOCALE
	INTEGER IEQ,IFACE,IJ,JF
	REAL*8 XLG,XFAC1
	REAL*8 RPP,RAP
	REAL*8 RPN,DNP,EPP,VPX
	


      SOMFLUX=0.D0      
	FLUX=0.D0

!-------------------------
                  DO 10 IFACE=2,4,2

            
 

	  XLG		=grid(i)%Lface(iface)
	  XFAC1	=grid(i)%nxl(iface) ! 
!
       FLUX(1)=vari(i,IFACE,1)*XFAC1 
       FLUX(3)=vari(i,IFACE,3)*XLG
            
              FLUX(4)= vari(i,IFACE,4)*XLG
            


               IF(IDIPHA.EQ.1)THEN
!       PARTICULES
                        DO JF=1,NFAM
	 IJ=(IEQ0-1)+6*(JF-1) 
	RPP=vari(i,IFACE,IJ+5)+vari(i,IFACE,IJ+6)
	RAP=RPP/ROPINJMIN
                        IF(RAP.GE.EPS)THEN
                         RPN=vari(i,IFACE,IJ+1)
                         DNP=vari(i,IFACE,IJ+3)
                         EPP=vari(i,IFACE,IJ+4)
                         VPX=RPN*XFAC1
                        
                  FLUX(IJ+1)=VPX*RPN/RPP
                  FLUX(IJ+3)=DNP*RPN/RPP*XLG
                  FLUX(IJ+4)=EPP*RPN/RPP*XLG
                  FLUX(IJ+5)=vari(i,IFACE,IJ+5)*RPN/RPP*XLG
                  FLUX(IJ+6)=vari(i,IFACE,IJ+6)*RPN/RPP*XLG
	                         ELSE
	
		      FLUX(IJ+1)=0.d0
                  FLUX(IJ+2)=0.d0
                  FLUX(IJ+3)=0.d0
                  FLUX(IJ+4)=0.d0
                  FLUX(IJ+5)=0.d0
                  FLUX(IJ+6)=0.d0
                         	ENDIF
                        ENDDO
                          ENDIF
!                      FIN IDIPHA

!    LA SOMME DES FLUX EST EFFECTIVEMENT CALCULEE

                     DO IEQ=1,NEQ1
                     SOMFLUX(IEQ)=SOMFLUX(IEQ)-FLUX(IEQ)
                     ENDDO




10                 CONTINUE		! Fin boucle sur les faces

	
	RETURN 
	END


!=======================================================================
       SUBROUTINE INTERCELL (VARP,VARI,ROGIL,ROGIR,ROGIS,		     &
          grid,IDIPHA,def_bloc,NX,NFAM,NEQ,NEQG,IEQSTARTP)



       use precisions    
	 use COURANT
       use geometrie     
       use PARAMETRE_EOS

	IMPLICIT NONE

	INTEGER NX,NFAM,NEQ,IDIPHA,NEQG,IEQSTARTP
        

        REAL*8 VARP(0:NX+1,4,NEQ)
        REAL*8 VARI(0:NX+1,4,NEQ)

	REAL*8 ROGIL,ROGIR,ROGIS



      type(maillage),dimension(0:NX+1),intent(in)      ::grid
	type(definition_domaine) ::def_bloc
!-----------------------------------------------------------------------
!   VARIABLES LOCALES
	INTEGER I,II,IJ,IFACE,IFA,IEQ,NIX,NF,IFL
	REAL*8 ROGL,VGNL,VGTL,EGL
	REAL*8 ROGR,VGNR,VGTR,EGR
	REAL*8 RR,RN,RT,ENR,GA,GAM1

!  ATTENTION ON LIMITE A 2 CLASSES DE PARTICULES
	REAL*8 RP(2),RUP(2),RVP(2),DN(2),EP(2)
	REAL*8 ROPL(2),VPNL(2),VPTL(2),DL(2)
	REAL*8 EPL(2),ROPOXL(2)
	REAL*8 ROPR(2),VPNR(2),VPTR(2),DR(2)
	REAL*8 EPR(2),ROPOXR(2)
	REAL*8 ROPALR(2),ROPALL(2),RPAL,RPOX
	REAL*8 AR,PR,AL,PL


		 
	NIX=def_bloc%nix
	IFL=1

	GA	=PARA_EOS(IFL,1)
	GAM1	=GA-1.d0
!-----------------------------------------------------------------------
! SECOND ETAPE : CALCUL DES FLUX PASSANT AU TRAVERS DE CHAQUE INTERFACE
!                 ON UTILISE LES VALEURS U(N+1/2,J+1/2)
!-----------------------------------------------------------------------

!-----------------  LIMITE OUEST     -------------------------------
	I=0
      IFACE = 2
	II=I+1
	IFA=IFACE+2


	CALL PREFLUL(VARP,-grid(i+1)%nx(4),GA,GAM1,			     &
        ROGL,VGNL,VGTL,EGL,ROGIL,AL,PL,					     &
        ROPL,VPNL,VPTL,DL,EPL,ROPALL,ROPOXL,				     &
        IFACE,I,NX,NFAM,NEQ,IEQSTARTP)	 


	CALL PREFLUR(VARP,-grid(i+1)%nx(4),GA,GAM1,			     &
        ROGR,VGNR,VGTR,EGR,ROGIR,AR,PR,				    	     &
        ROPR,VPNR,VPTR,DR,EPR,ROPALR,ROPOXR,			   	     &	
        IFACE+2,I+1,NX,NFAM,NEQ,IEQSTARTP)
!--------------------------------------------------------------------

	CALL FLUHLLC(VGNL,VGTL,EGL,ROGL,ROGIL,PL,AL,			     &
                       VGNR,VGTR,EGR,ROGR,ROGIR,PR,AR, 		     &
                        RN,RT,ENR,RR,ROGIS)

           vari(i,IFACE,1)=RN
           vari(i,IFACE,2)=RT
           vari(i,IFACE,3)=ENR
	 
	  vari(i,IFACE,4)=ROGIS
	 

!   PARTICULES
          IF(IDIPHA.EQ.1)THEN
           DO NF=1,NFAM
            CALL PRMN(ROPL(NF),VPNL(NF),VPTL(NF),DL(NF),EPL(NF),       &
            ROPR(NF),VPNR(NF),VPTR(NF),DR(NF),EPR(NF),		     &
            ROPALL(NF),ROPOXL(NF),ROPALR(NF),ROPOXR(NF),RPAL,RPOX,     &
            RP(NF),RUP(NF),RVP(NF),DN(NF),EP(NF))

            IJ=IEQSTARTP+6*(NF-1)
            vari(i,IFACE,IJ+0)=RUP(NF)
            vari(i,IFACE,IJ+1)=RVP(NF)
            vari(i,IFACE,IJ+2)=DN(NF)
            vari(i,IFACE,IJ+3)=EP(NF)

            vari(i,IFACE,IJ+4)=RPAL
            vari(i,IFACE,IJ+5)=RPOX
           ENDDO

          ENDIF	


!----------------------------------------------------------------------
!  		POINT COURANT
!----------------------------------------------------------------------

 			   DO 200 I=1,NIX

                              IFACE = 2

	II=I+1
	IFA=IFACE+2
	
	CALL PREFLUL(VARP,							     &
         grid(i)%nx(IFACE),GA,GAM1,						     &
        ROGL,VGNL,VGTL,EGL,ROGIL,AL,PL,					     &
        ROPL,VPNL,VPTL,DL,EPL,ROPALL,ROPOXL,				     &
        IFACE,I,NX,NFAM,NEQ,IEQSTARTP)	

	CALL PREFLUR(VARP,							     &
         grid(i)%nx(IFACE),GA,GAM1,						     &
        ROGR,VGNR,VGTR,EGR,ROGIR,AR,PR,					     &
        ROPR,VPNR,VPTR,DR,EPR,ROPALR,ROPOXR,				     &
        IFACE+2,I+1,NX,NFAM,NEQ,IEQSTARTP)

!   GAZ
       CALL FLUHLLC(VGNL,VGTL,EGL,ROGL,ROGIL,PL,AL,			     &
                    VGNR,VGTR,EGR,ROGR,ROGIR,PR,AR,			     &
                    RN,RT,ENR,RR,ROGIS)


!            RANGEMENT DE L'ETAT A L'INTERFACE (ENTRE CELLULES)
!
           vari(i,IFACE,1)=RN
           vari(i,IFACE,2)=RT
           vari(i,IFACE,3)=ENR  
	  vari(i,IFACE,4)=ROGIS
	 

!    PARTICULES
          IF(IDIPHA.EQ.1)THEN
           DO NF=1,NFAM
             CALL PRMN(ROPL(NF),VPNL(NF),VPTL(NF),DL(NF),EPL(NF),      &
           ROPR(NF),VPNR(NF),VPTR(NF),DR(NF),EPR(NF),			     &
           ROPALL(NF),ROPOXL(NF),ROPALR(NF),ROPOXR(NF),RPAL,RPOX,      &
           RP(NF),RUP(NF),RVP(NF) ,DN(NF),EP(NF))

            
            IJ=IEQSTARTP+6*(NF-1)
            vari(i,IFACE,IJ+0)=RUP(NF)
            vari(i,IFACE,IJ+1)=RVP(NF)
            vari(i,IFACE,IJ+2)=DN(NF)
            vari(i,IFACE,IJ+3)=EP(NF)
            vari(i,IFACE,IJ+4)=RPAL
            vari(i,IFACE,IJ+5)=RPOX
           ENDDO

          ENDIF



			IFACE = 4

	
 
           DO IEQ=1,NEQG
            vari(i,IFACE,IEQ)=- VARI(I-1,2,IEQ)
           ENDDO
           vari(i,IFACE,1)=-vari(i,IFACE,1)
           vari(i,IFACE,2)=-vari(i,IFACE,2)




	IF(IDIPHA.EQ.1) THEN
           DO IEQ=IEQSTARTP,NEQ
            vari(i,IFACE,IEQ)=VARI(I-1,IFACE-2,IEQ)
             ENDDO
           DO NF=1,NFAM
            IJ=IEQSTARTP+6*(NF-1)
            vari(i,IFACE,IJ+0)=-vari(i,IFACE,IJ+0)
            vari(i,IFACE,IJ+1)=-vari(i,IFACE,IJ+1)
           ENDDO     
	END IF


210    CONTINUE
200    CONTINUE

		 

		RETURN
		END

!=======================================================================
          SUBROUTINE LIMGAZ(def_bloc,VAR,NX,NEQ,NEQG)
       use precisions    
	 use COURANT
	 use geometrie
                  IMPLICIT NONE


	INTEGER NX,NEQ,NEQG
	
	REAL*8  VAR(0:NX+1,NEQ)	
	 type(definition_domaine) ::def_bloc
 	
! VARAIBLE LOCALE
	INTEGER IEQ
	INTEGER NIX
	
	NIX=def_bloc%nix
!  limite gauche
	If(def_bloc%type_limite(1)==1) then
            DO IEQ=1,NEQG
              VAR(0,IEQ)=VAR(1,IEQ)
		END DO
	end if
	If(def_bloc%type_limite(1)==2) then  
 		DO IEQ=1,NEQG
              VAR(0,IEQ)=VAR(1,IEQ)
		END DO     
              VAR(0,1)=-VAR(1,IEQ)
	
 	end if


! limite droite

	If(def_bloc%type_limite(2)==1) then  
            DO IEQ=1,NEQG
              VAR(NIX+1,IEQ)=VAR(NIX,IEQ)
            END DO
	end if


	If(def_bloc%type_limite(2)==2) then  
		DO IEQ=1,NEQG
              VAR(NIX+1,IEQ)=VAR(NIX,IEQ)
            END DO
		 VAR(NIX+1,1)=-VAR(NIX,1)
	end if
	return
	end


!=======================================================================
        SUBROUTINE LIMPAR(def_bloc,VAR,NX,NEQ,IEQSTARTP)

       use precisions    
	 use COURANT
	 use geometrie
                  IMPLICIT NONE
	INTEGER NX,NEQ,IEQSTARTP
      REAL*8 VAR(0:NX+1,NEQ) 
	type(definition_domaine) ::def_bloc
      	
! VARIABLES LOCALES
	INTEGER NIX,IEQ


	NIX=def_bloc%nix
!  limite gauche
	If(def_bloc%type_limite(1)==1) then
           DO IEQ=IEQSTARTP,NEQ
              VAR(0,IEQ)=VAR(1,IEQ)   
           END DO
	END IF
	If(def_bloc%type_limite(1)==2) then
           DO IEQ=IEQSTARTP,NEQ
              VAR(0,IEQ)=VAR(1,IEQ)   
           END DO
	        VAR(0,IEQSTARTP)=-VAR(1,IEQSTARTP)   
	END IF


! limite  droite
	If(def_bloc%type_limite(2)==1) then
           DO IEQ=IEQSTARTP,NEQ
              VAR(NIX+1,IEQ)=VAR(NIX,IEQ)
           END DO
	end if
	If(def_bloc%type_limite(2)==2) then
           DO IEQ=IEQSTARTP,NEQ
              VAR(NIX+1,IEQ)=VAR(NIX,IEQ)
           END DO
		  VAR(NIX+1,IEQSTARTP)=-VAR(NIX,IEQSTARTP)
	end if


	 

	RETURN
	END


!=======================================================================
	SUBROUTINE PREFLUL(VARP,DNX,GA,GAM1,				     &
         ROGL,VGNL,VGTL,EGL,ROGI,AL,PL,					     &
        ROPL,VPNL,VPTL,DL,EPL,ROPALL,ROPOXL,				     &
        IFAC,I,NX,NFAM,NEQ,IEQ0)


       use dimension_probleme


	IMPLICIT NONE

	INTEGER I,NX,NFAM,NEQ,IFAC,IEQ0
	
	
	REAL*8 VARP(0:NX+1,4,NEQ)
	REAL*8 ROGI
	REAL*8 DNX
! GAZ
	REAL*8 ROGL,VGNL,VGTL,EGL,PL,AL
! PARTICULE
        REAL*8 VPNL(2),VPTL(2),DL(2),EPL(2),ROPL(2)
	REAL*8 ROPALL(2),ROPOXL(2)
	REAL*8 GA,GAM1

!  VARIABLE LOCALE
	INTEGER IJ,NF
	REAL*8 EIL
	
	
!-----------------------------------------------------------------------
! 		 DEFINITION DE L'ETAT GAUCHE      
!-----------------------------------------------------------------------
      VGNL	= varp(i,IFAC,1)*DNX  
      VGTL	= varp(i,IFAC,2)*DNX
      EGL  	= varp(i,IFAC,3)
	
	
	ROGI= varp(i,IFAC,4)
	ROGL= varp(i,IFAC,4)
	EIL =(EGL -0.5D0*(VGNL*VGNL+ VGTL*VGTL)/ROGL)/ROGL
	pl=gam1*rogL*eiL
	AL=dsqrt(GA*PL/ROGL)

    
!
!      PARTICULES

         DO NF=1,NFAM
	 IJ=(IEQ0-1)+6*(NF-1) 

          ROPL(NF)=varp(i,IFAC,IJ+5)+varp(i,IFAC,IJ+6)
          VPNL(NF)=varp(i,IFAC,IJ+1)*DNX
          VPTL(NF)=varp(i,IFAC,IJ+2)*DNX
          DL(NF)	=varp(i,IFAC,IJ+3)
          EPL(NF)	=varp(i,IFAC,IJ+4)
          ROPALL(NF)	=varp(i,IFAC,IJ+5)
          ROPOXL(NF)	=varp(i,IFAC,IJ+6)
         ENDDO

	RETURN 
	END
!=======================================================================
	SUBROUTINE PREFLUR(VARP,DNX,GA,GAM1,				     &
         ROGR,VGNR,VGTR,EGR,ROGI,AR,PR,					     &
         ROPR,VPNR,VPTR,DR,EPR,ROPALR,ROPOXR,				     &
         IFAC,I,NX,NFAM,NEQ,IEQ0)


       use dimension_probleme

	IMPLICIT NONE

	INTEGER I,NX,NFAM,NEQ,IFAC,IEQ0
	
 	REAL*8 VARP(0:NX+1,4,NEQ)
	REAL*8 DNX
! GAZ
	REAL*8 ROGR,VGNR,VGTR,EGR,PR,AR
	REAL*8 ROGI

! PARTICULE
        REAL*8 VPNR(2),VPTR(2),DR(2),EPR(2),ROPR(2)
	REAL*8 ROPALR(2),ROPOXR(2)

!  VARIABLE LOCALE
	INTEGER IJ,NF
	REAL*8 EIR,GA,GAM1


!-----------------------------------------------------------------------
! 		 DEFINITION DE L'ETAT DROIT      
!-----------------------------------------------------------------------
!   GAZ
	VGNR=varp(i,IFAC,1)*DNX 
	VGTR=varp(i,IFAC,2)*DNX
	EGR=varp(i,IFAC,3)

 
	ROGR	=varp(i,IFAC,4)
	ROGI    =varp(i,IFAC,4)
 
     
	EIR =(EGR -0.5D0*(VGNR*VGNR+ VGTR*VGTR)/ROGR)/ROGR
	pr=gam1*rogr*eir
	Ar=dsqrt(GA*Pr/ROGr)
! PARTICULES
           DO NF=1,NFAM
	 IJ=(IEQ0-1)+6*(NF-1) 
           ROPR(NF)=varp(i,IFAC,IJ+5)+varp(i,IFAC,IJ+6)
           VPNR(NF)	=varp(i,IFAC,IJ+1)*DNX 
           VPTR(NF)	=varp(i,IFAC,IJ+2)*DNX
           DR(NF)		=varp(i,IFAC,IJ+3)
           EPR(NF)	=varp(i,IFAC,IJ+4)
          ROPALR(NF)	=varp(i,IFAC,IJ+5)
          ROPOXR(NF)	=varp(i,IFAC,IJ+6)
           ENDDO

	RETURN 
	END
!=========================================================================
	SUBROUTINE PRIM(cell_gaz,cell_part,def_bloc,			     &
                   VAR,GRD_PRIM,						     &
                   EPS,ROPINJMIN,   					     &
                   NX,NEQ,NFAM,IDIPHA,IEQSTARTP)

       use precisions   
	 use COURANT
	 use dimension_probleme
       use PARAMETRE_EOS
	 use geometrie
       		IMPLICIT NONE


	INTEGER NX,NEQ,IEQSTARTP,NFAM,IDIPHA


!  GAZ

       
	REAL*8 ROPINJMIN,EPS
 	type(definition_domaine) ::def_bloc
	type(cellule_gaz),dimension(0:NX+1),intent(out) ::cell_gaz
	type(cellule_part),dimension(0:NX+1,NFAM),intent(out)  	     & 
                                                         ::cell_part
!   SCHEMA
       REAL*8   VAR(0:NX+1,NEQ)
       REAL*8   GRD_PRIM(0:NX+1,NEQ)	


!
!   VARIABLES LOCALES
	INTEGER I,IJ,NIX,NF,IFL
	REAL*8 E,PI,ROREEL1,ROREEL2
	REAl*8 GA,GAP1,GAM1,CV
	REAL*8 CPP1,CPP2,CPP,VOLAL,VOLOXYDE,VOL,YAL
	real(kind=dp) ::rog,UG,PG,TG,VIT_SON
	real(kind=dp) ::rop,up,nbre,diam,tp

		

	     PI=DACOS(-1.D0)

	
	IFL=1

	NIX=def_bloc%nix

!-----------------------------------------------------------------------

	GA	=PARA_EOS(IFL,1)
	GAp1	=GA+1.d0
	GAM1	=GA-1.d0	
	CV	=PARA_EOS(IFL,2)



	 
        DO 100 I=0,NIX+1

	 ROG= VAR(I,4)  
     UG	=VAR(I,1)/ROG 
	 E=VAR(I,3)-0.5D0*ROG*UG**2

	e=e/rog
	pG=gam1*rog*e
	TG=e/CV
	vit_son=dsqrt(ga*pg/rog)

	cell_gaz(i)%ro =ROG
	cell_gaz(i)%u  =UG  
	cell_gaz(i)%p  =PG
	cell_gaz(i)%c  =VIT_SON
	cell_gaz(i)%t  =TG
	


!====================================================================
!  affectation des grandeurs primitives
	 GRD_PRIM(I, 1) = cell_gaz(i)%u
     GRD_PRIM(I, 3) = cell_gaz(i)%P
	 GRD_PRIM(I, 4)	=VAR(I,4)
 

100	CONTINUE

!---PARTCIULES	
	IF(IDIPHA.EQ.1) THEN


        DO 101 NF=1,NFAM
	roreel1=PARA_part(NF,1)
	roreel2=PARA_part(NF,1)
	CPP1	=PARA_part(NF,2) 
	CPP2	=PARA_part(NF,2)         
	IJ=(IEQSTARTP-1)+6*(NF-1)	
!-----------------------------------------------------------------------

 
	DO 101 I=0,NIX+1


	ROP	=VAR(I,IJ+5)+VAR(I,IJ+6)
      cell_part(I,NF)%rop=rop

	IF(ROP/ROPINJMIN.LT.EPS)THEN

                 UP			=0.D0
                 NBRE			=0.D0
                 ROP 			=0.D0
                 TP			=0.D0
		     DIAM			=0.D0
            cell_part(I,NF)%up	=0.d0
            cell_part(I,NF)%rop	=0.d0
            cell_part(I,NF)%nbre	=0.d0
            cell_part(I,NF)%tp	=0.d0
            cell_part(I,NF)%diam	=0.d0	
		
		VAR(I,IJ+1)=0.d0
		VAR(I,IJ+2)=0.d0
		VAR(I,IJ+3)=0.d0
		VAR(I,IJ+4)=0.d0
		VAR(I,IJ+5)=0.d0
		VAR(I,IJ+6)=0.d0

                ELSE

 	UP		=VAR(I,IJ+1)/ROP
	NBRE		=VAR(I,IJ+3)
	YAL		=VAR(I,IJ+5)/ROP

	CPP=YAL*CPP1+(1.D0-YAL)*CPP2
      VOLAL	= VAR(I,IJ+5)/ROREEL1   /NBRE 
        VOLOXYDE= VAR(I,IJ+6)/ROREEL2/NBRE 
	VOL=VOLAL+VOLOXYDE

	TP	=VAR(I,IJ+4)/ROP/CPP
	DIAM	=(6.D0/PI*VOL)**(1.D0/3.D0)

            cell_part(I,NF)%up	=UP
            cell_part(I,NF)%nbre	=NBRE
            cell_part(I,NF)%tp	=TP
            cell_part(I,NF)%diam	=DIAM	
!   AFFECTATION DES GRANDEURS CONSERVATIVES

	 GRD_PRIM(I, IJ+1) = UP
       GRD_PRIM(I, IJ+3) = NBRE
       GRD_PRIM(I, IJ+4) = TP
	 GRD_PRIM(I, IJ+5) =VAR(I,IJ+5)
	 GRD_PRIM(I, IJ+6) =VAR(I,IJ+6)


		     ENDIF

101      CONTINUE
			END IF ! fin diphasique
         RETURN
         END

!=========================================================================


!=======================================================================
        SUBROUTINE PRMN(RPG,VPUG,VPVG,DNG,EPG,RPD,VPUD,VPVD,	     &
         DND,EPD,RPG1,RPG2,RPD1,RPD2,RP1,RP2,				     &
         RP,RUP,RVP,DN,EP)

      		  IMPLICIT NONE
	REAL*8 RPG,VPUG,VPVG,DNG,EPG,RPD,VPUD,VPVD
        REAL*8 DND,EPD,RP,RUP,RVP,DN,EP,RPG1,RPG2
        REAL*8 RPD1,RPD2,RP1,RP2





       			 IF(VPUG.LE.VPUD)THEN
          IF(VPUG.GT.0.D0)THEN
!            CAS 1  : DETENTE A DROITE
             RP	=RPG
             RP1=RPG1
             RP2=RPG2
             DN	=DNG
             RUP=VPUG
             RVP=VPVG
             EP=EPG
          END IF
             IF(VPUG.LE.0.D0.AND.VPUD.GE.0.D0)THEN
!            CAS 2 : VIDE
              RP=0.D0
              RP1=0.D0
              RP2=0.D0
              DN=0.D0
              RUP=0.D0
              RVP=0.D0
              EP=0.D0
             END IF
!            CAS 3 : DETENTE A GAUCHE	
             IF(VPUD.LT.0.D0)THEN
              RP=RPD
              RP1=RPD1
              RP2=RPD2
              DN=DND
              RUP=VPUD
              RVP=VPVD
              EP=EPD
             ENDIF
!       FIN DETENTE
		        END IF

!-----------------------------------------------------------------------
! Compression       
			IF(VPUG.gt.VPUD)THEN
          IF(VPUD.GE.0.D0)THEN
!     CAS 4 : COMPRESSION A DROITE
             DN=DNG
             RP=RPG
             RP1=RPG1
             RP2=RPG2
             RUP=VPUG
             RVP=VPVG
             EP=EPG
          END IF

             IF(VPUG*VPUD.LT.0.D0)THEN
!   CAS 5 : CHOC DE PARTICULES
              DN=DNG+DND
              RP=RPG+RPD
              RP1=RPG1+RPD1
              RP2=RPG2+RPD2
              RUP=VPUG+VPUD
              RVP=VPVG+VPVD
              EP=EPG+EPD
             end if

!    CAS 6 : COMPRESSION A GAUCHE
	 IF(VPUG.LE.0.D0)THEN
	DN=DND
	RP=RPD
	RP1=RPD1
	RP2=RPD2
	RUP=VPUD
	RVP=VPVD
	EP=EPD
	 ENDIF
       
        	 ENDIF
         RETURN
         END

!=======================================================================






























































































































